"""
<<<<<<< ReportTable.py
$Id: ReportTable.py,v 1.33 2002/05/29 03:08:06 evonnied Exp $
=======
$Id: ReportTable.py,v 1.33 2002/05/29 03:08:06 evonnied Exp $
>>>>>>> 1.32
"""
##############################################################################
## copyright (C) 2002 Eugene von Niederhausern
##
##
##    This file is part of niederworksBRIDGE.
##
##    niederworksBRIDGE is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 2 of the License, or
##    (at your option) any later version.
##
##    niederworksBRIDGE is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with niederworksBRIDGE; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
##############################################################################


import string
from Globals import Persistent, PersistentMapping,InitializeClass

from AccessControl import ClassSecurityInfo

from Acquisition import Implicit, aq_base,aq_inner, aq_parent

from Products.CMFCore import CMFCorePermissions

import niederworksBRIDGEPermissions 

from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from OFS.SimpleItem import SimpleItem
from Products.ZSQLMethods import SQL
from Products.CMFCore.utils import getToolByName

permissions = niederworksBRIDGEPermissions

factory_type_information = ( {'id'             : 'Report Table'
                              , 'meta_type'    : 'niederWorks Report Table'
                              , 'description'  : 'Report Table is a template that users build reports with'
                              , 'icon'         : 'reporttable_icon.gif'
                              , 'product'      : 'niederworksBRIDGE'
                              , 'factory'      : 'addReportTable'
                              , 'actions'        :
                                    ( { 'id'           : 'view'
                                        ,'name'        : 'View'
                                        ,'action'      : 'reporttable_view'
                                        ,'permissions' : ( CMFCorePermissions.View,)
                                       }
                                      , { 'id'         : 'edit'
                                          ,'name'      : 'Edit'
                                          ,'action'    : 'reporttable_edit_form'
                                          ,'permissions':( permissions.ModifyReportTable,)
                                        }
                                      ,),
                              },)

def addReportTable(self
                   ,id
                   ,title = ''
                   ,description = ''
                   ,report_type = ''
                   , tables = ''
                   , REQUEST = None):
    """ Create a new report table """
    reporttable = ReportTable(id,title,description,report_type)
    self._setObject(id,reporttable)

class ReportTable(PortalContent,Persistent,Implicit,DefaultDublinCoreImpl):
    meta_type = 'niederWorks Report Table'

    security = ClassSecurityInfo()

    def __init__(self
                 , id
                 , title = ''
                 , description = ''
                 , report_type = ''
                 , connection_id = ''
                 , table = ''
                 ):
        DefaultDublinCoreImpl.__init__(self)
        self.id = id
        self.setTitle(title)
        self.setDescription(description)
        self.report_type = report_type
        self._allowed_roles = ()
        self._fields = PersistentMapping()
        self._connection_id = connection_id
        if self.connectionId() and self.connectionId() != connection_id:
            self._set_dbtype()
        self._table = table

    security.declareProtected(permissions.ModifyReportTable,'edit')
    def edit(self, title = ''
                 , description = ''
                 , report_type = ''
                 , connection_id = ''
                 , table = ''
             ):
        self.setTitle(title)
        self.setDescription(description)
        self.report_type = report_type
        self._connection_id = connection_id
        if self.connectionId() and self.connectionId() != connection_id:
            self._set_dbtype()
            
        self._table = table

    
    def _set_dbtype(self):
        rd_tool = getToolByName(self,'portal_reportdata')
        con = rd_tool.getDataConnection(self.connectionId())
        if con:
            if string.lower(con.meta_type).find('popy')>= 0:
                self._db_type = 'pgsql'
            elif string.lower(con.meta_type).find('mysql') >= 0:
                self._db_type = 'mysql'
            else:
                self._db_type = 'generic'
        else:
            self._db_type = 'generic'
            
    security.declarePublic('dbType')
    def dbType(self):
        self._db_type = getattr(self,'_db_type','generic')
        if self._db_type:
            return self._db_type
        
        return 'generic'
    
    security.declarePublic('physical_path')
    def physical_path(self):
        pp=self.getPhysicalPath()
        return string.join(pp,'/')
    
    security.declarePublic('table')
    def table(self):
        """ return the table we are based on """
        return self._table

    security.declarePublic('connectionId')
    def connectionId(self):
        return self._connection_id
    
    security.declarePublic('reportTableFields')
    def reportTableFields(self):
        """TEST"""
        v = []
        fields = self._fields.keys()
        fields.sort()
        for k in fields:
            v.append(self._fields[k])
        return v
    def reportTableFieldsVisible(self):
        """TEST"""
        v = []
        for k in self.reportTableFields():
            if k.isVisible():
                v.append(k)
        return v


    security.declarePublic('hasAggregate')        
    def hasAggregate(self):
        for urf in self.reportTableFields():
            if urf.aggregateFunc() and len(urf.aggregateFunc()) > 0 :
                return 1
        return 0

    
    security.declarePublic('reportTableFieldNames')
    def reportTableFieldNames(self):
        """TEST"""
        v = []
        for k in self._fields.keys():
            v.append(k)
        return v
    security.declarePublic('getReportTableField')
    def getReportTableField(self,field_name):        
        if self._fields.has_key(field_name):
            field = self._fields[field_name]
            return field.__of__(self)

        return None
    
    def __getattr__(self,name):
        if self._fields.has_key(name):
            return self.getReportTableField(name)
        raise AttributeError,'%s not found' % (name)
    security.declareProtected(permissions.ModifyReportTable,'deleteReportTableField')
    def deleteReportTableField(self,id):
        del self._fields[id]

    security.declareProtected(permissions.ModifyReportTable,'addReportTableField')
    def addReportTableField(self
                            , id
                            , title = ''
                            , description = ''
                            , field_name = ''
                            , searchable = 0
                            , aggregate = 0
                            , sortable = 0
                            , visible = 1
                            , data_type = 'text'
                            , default_value = None
                            ):
        if self._fields.has_key(id) :
            raise 'FIELD_EXISTS','Field already Exists %s' % (id)
        
        rtf = ReportTableField(
            id
            ,title
            ,description
            ,field_name
            ,searchable
            ,aggregate
            ,sortable
            ,visible
            ,data_type
            ,default_value
            )
        self._fields[id] = rtf
        return rtf

InitializeClass(ReportTable)

    
class ReportTableField(Persistent,Implicit,SimpleItem):
    meta_type = 'niederWorks Report Table Field'
    
    security = ClassSecurityInfo()
    
    def __init__(self
                 , id
                 , title = ''
                 , description = ''
                 , field_name = ''
                 , searchable = 0
                 , aggregate = 0
                 , sortable = 0
                 , visible = 1
                 , data_type = 'text'
                 , default_value = None
                 , value_list = None
                 , default_operator='='
                 ):
        self.id = id
        self.title = title
        self.description = description
        self._field_name = field_name
        self._searchable = searchable
        self._aggregate = aggregate
        self._sortable = sortable
        self._visible = visible
        self._data_type = data_type

        self._default_value = default_value
        self._value_list = value_list
        self._default_operator = default_operator

    security.declareProtected(niederworksBRIDGEPermissions.ModifyReportTable,'edit')    
    def edit(self
                 , title = ''
                 , description = ''
                 , field_name = ''
                 , searchable = 0
                 , aggregate = ''
                 , sortable = 0
                 , visible = 1
                 , data_type = 'text'
                 , default_value = ''
                 , value_list = ''
                 , default_operator ='='
                 ):
        """ Edit a report table field"""
        self.title = title
        self.description = description
        self._field_name = field_name
        if searchable is None:
            searchable=0
        
        self._searchable = int(searchable)
        if aggregate is None:
            aggregate=0
            
        self._aggregate = aggregate
        if sortable is None:
            sortable = 0
            
        self._sortable = int(sortable)
        
        if visible is None:
            visible=0
            
        self._visible = int(visible)
        self._data_type = data_type
        self._default_value = default_value
        self._value_list = value_list
        self._default_operator = default_operator

        
    security.declarePublic('Title')
    def Title(self):
        return self.title

    def Description(self):
        return self.description
    security.declarePublic('fieldName')
    def fieldName(self):
        return self._field_name
    
    security.declarePublic('isAggregate')
    def aggregateFunc(self):
        return self._aggregate
    def isAggregate(self):
        o = 0
        if self._aggregate and len(self._aggregate) > 0:
            o = 1

        return o
    
    security.declarePublic('isSortable')
    def isSortable(self):
        return self._sortable
    security.declarePublic('isSearchable')
    def isSearchable(self):
        return self._searchable

    security.declarePublic('isVisible')
    def isVisible(self):
        return self._visible

    security.declarePublic('dataType')
    def dataType(self):
        
        if self.isAggregate() and self.aggregateFunc() not in ['min(%s)','max(%s)']: 
            return 'number'
        else:
            return self._data_type
    security.declarePublic('defaultVvalue')
    def defaultValue(self):
        if self._default_value is not None and len(self._default_value) > 0:
            return self._default_value
        return None
    
    def defaultOperator(self):
        if self._default_operator and len(self._default_operator) > 0:
            return self._default_operator
        return None
    
    security.declarePublic('valueList')
    def valueList(self):
        return self._value_list

        
InitializeClass(ReportTableField)
