"""
$Id: __init__.py,v 1.10 2002/05/28 23:53:07 evonnied Exp $
"""
##############################################################################
## copyright (C) 2002 Eugene von Niederhausern
##
##
##    This file is part of niederworksBRIDGE.
##
##    niederworksBRIDGE is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 2 of the License, or
##    (at your option) any later version.
##
##    niederworksBRIDGE is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with niederworksBRIDGE; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
##############################################################################



ADD_CONTENT_PERMISSION = 'Add portal content'
 
from Products.CMFDefault import Portal
import ReportDataTool, UserReport, ReportTable
from Products.CMFCore import utils
import Products.CMFCore
from Products.CMFCore.DirectoryView import registerDirectory
#import PortalGenerator


contentClasses = ( UserReport.UserReport
                 , ReportTable.ReportTable
                 )


contentConstructors = ( UserReport.addUserReport
                        , ReportTable.addReportTable
                      )

bases = contentClasses
        

tools = ( ReportDataTool.ReportDataTool,
        )

import sys
this_module = sys.modules[ __name__ ]

z_bases = utils.initializeBasesPhase1( bases, this_module )
z_tool_bases = utils.initializeBasesPhase1( tools, this_module )

cmfdefault_globals=globals()

fti=ReportTable.factory_type_information + UserReport.factory_type_information

# Make the skins available as DirectoryViews.
registerDirectory('skins', globals())
registerDirectory('skins/niederworksBRIDGE', globals())
registerDirectory('skins/niederworksZPT', globals())


def initialize( context ):

    utils.initializeBasesPhase2( z_bases, context )
    utils.initializeBasesPhase2( z_tool_bases, context )
    utils.ToolInit('niederworksBRIDGE Report Tool', tools=tools,
                   product_name='niederworksBRIDGE', icon='tool.gif',
                   ).initialize( context )

    utils.ContentInit( 'niederworksBRIDGE Content'
                     , content_types=contentClasses
                     , permission=ADD_CONTENT_PERMISSION
                     , extra_constructors=contentConstructors
                     , fti=fti
                     ).initialize( context )

#    context.registerClass(Portal.CMFSite,
#                          constructors=(PortalGenerator.manage_addCMFSiteForm,
#                                        PortalGenerator.manage_addCMFSite,
#                                        ),
#                          icon='portal.gif')
#    utils.registerIcon(DefaultWorkflow.DefaultWorkflowDefinition,
#                       'images/workflow.gif', globals())
    
    #context.registerHelp()
    #context.registerHelpTitle('CMF Default Help')
